unit GuitarChords1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Buttons, ExtCtrls,
	 StdCtrls;

type


   TChord = array[0..5] of Integer;

   TSemiTone = (sC,sCis,sD,sDis,sE,SF,sFis,sG,sGis,sA,sAis,sH);

	 { TForm1 }

   TForm1 = class(TForm)
			Button2: TButton;
			Button3: TButton;
			CheckBox1: TCheckBox;
			GroupBox1: TGroupBox;
			Image1: TImage;
			RadioGroup1: TRadioGroup;
			RadioGroup2: TRadioGroup;
			RadioGroup3: TRadioGroup;
      procedure Button2Click(Sender: TObject);
			procedure Button3Click(Sender: TObject);
      Procedure DrawChord (aChord : TChord; BarreAt: Integer; YOff : integer);
      procedure BuildSet;
      procedure BuildFretBoard(BarreAt : Integer);
			procedure FormCreate(Sender: TObject);

   private
   ChordSet : Set of TSemiTone;
   FretBoard : TChord;
   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

const FretbordDist = 150;

// von hoch nach tief
const Guitar : TChord = (Ord(sE),ord (sH),Ord(SG),Ord(SD), ord(SA), Ord(sE));

// Abstang Halbtöne, nur positive
function ToneDistance (T1,T2 : TSemiTone): integer;
var i1,i2 : Integer;
begin
i1 := Ord(T1);
i2 := Ord (T2);
result := abs(i1-i2);

end;

Procedure TForm1.DrawChord (aChord : TChord; BarreAt: Integer; YOff : integer);
const Bundlen = 48;
      SaitenDY =16;
      offsetX = 20;
      offsetY= 40;
      PressZero ='◎';
      Press = '◆';
      //PressZero='😎';
      //Press = '😊';

var i,x,y,dx,x1,y1 : Integer;
    s : string;
begin
With Image1.Canvas do
   begin
   // Saiten
   Pen.Color := clRed;
   for i := 0 to 5 do
       line (offsetX, Yoff+offsety+i*SaitenDy,Image1.width,yOff+offsety+i*SaitenDy);

   // Sattel
   x := OffsetX;
   Pen.Color := clBlack;
   Pen.width := 3;
   line (x,OffsetY+Yoff,x,OffsetY+Yoff + 5* SaitenDy);

   // Bünde
   Pen.width := 1;
   Pen.Color := clBlue;
   i := 0;
   while x < Image1.Width do
       begin
       line (x,OffsetY+Yoff,x,OffsetY+Yoff + 5* SaitenDy);
       s := IntToStr(i);
       dx := TextWidth(s) div 2;
       TextOut (x-dx,OffsetY+Yoff + 5* SaitenDy+3,s);
       // Bundmarker
       if (odd(i) and NOT (i in [1,11,13])) or (i=12) then
         begin
         x1 := x - bundlen div 2;
         Pen.Color := clSilver;
         Brush.Color := clSilver;
         if i = 12 then
           begin
           y1 := Yoff+offsetY+round (1.5*SaitenDY);
           EllipseC(x1,y1,6,6);
           y1 := Yoff+offsetY+round (3.5*SaitenDY);
           EllipseC(x1,y1,6,6);
					 end else
           begin
	          y1 := Yoff+offsetY+round (2.5* SaitenDY);
	          EllipseC(x1,y1,6,6);
         end;
         Pen.Color := clBlue;
         Brush.Color := clNone;
				 end;
       inc(i);
       inc (x,BundLen);
			 end;
    // Barre Symbol
   if BarreAt > 0 then
      begin
      x := offsetX+ BarreAt*Bundlen - 10;
      Pen.Color := $87B8DE;
      Pen.width := 10;
      Line (x, OffsetY+Yoff,x,OffsetY+Yoff+5*SaitenDy);
      Pen.width := 1;
			end;
   Brush.Style := bsClear;
   // Finger Symbole
	 for i :=0 to 5 do
     begin
     if aChord [i] = 0 then s := PressZero else s := Press;
     if achord[i] = 0 then x := Offsetx+2 else x := offsetX+ aChord[i]*Bundlen - 15;
     y := yOff+offsetY + i * SaitenDY- TextHeight(s) div 2;
     if (achord[i] = 0) or (achord[i] <> BarreAt) then TextOut (x,y,s);
		 end; // i
   Brush.Style := bsSolid;
	 end; // with

end;

procedure TForm1.FormCreate(Sender: TObject);
var s : string;
    T : TSemiTone;
begin
for T := Low(TSemiTone) to high(TSemiTone) do
   begin
   writeStr(s,T);
   delete (s,1,1);
   RadioGroup1.Items.add(s);
	 end;
RadioGroup1.ItemIndex := 0;
Image1.Canvas.Brush.Color := clWhite;
Image1.Canvas.FillRect (0,0,Image1.Width,Image1.Height);
end;

Procedure TForm1.BuildFretBoard (BarreAt: Integer);
var i,k, finger: integer;
    T : TSemiTone;
    found : Boolean;
begin
for i := 0 to 5 do
  begin
   k := Guitar[i]+BarreAt;
   finger := BarreAt;
   repeat
   T := TSemiTone(k mod 12);
   found := T in ChordSet;
   if found then FretBoard[i] := finger else
      begin
      inc (finger);
      inc(k);
			end;
	 until found;
	end;
end;

procedure TForm1.BuildSet;
var i,k, terz, sept : Integer;
    s : String = '';

begin
ChordSet := [];
i := RadioGroup1.ItemIndex;
Include(ChordSet, TSemiTone(i) );
if RadioGroup2.ItemIndex = 0 then Terz := 4 else Terz := 3;
k := (i+Terz) mod 12;
Include(ChordSet, TSemiTone(k) );
k := (i + 7) mod 12; // Quint
Include(ChordSet, TSemiTone(k) );
if RadioGroup3.ItemIndex > 0 then
  begin
  case RadioGroup3.ItemIndex of
  1: Sept := 11;   //  große
  2: sept := 10;   // kleine
  3 : sept := 9;   // verminderte
	end; // case
  k := (i+sept) mod 12;
  Include(ChordSet, TSemiTone(k) );
	end;// if
(* Test
for T := Low(TSemiTone) to High(TSemiTone) do
   begin
   if T in ChordSet then
        begin
        writeStr(tmp,t);
        s := s + tmp+LineEnding;
				end;
	 end;
showMessage (s);
*)
end;


function FingersOK (FretBoard : TChord; BarreAt: Integer): Boolean;
var i, count : integer;
begin
Count := 0;
 for i := 0 to 5 do if FretBoard[i] <> BarreAt then inc (Count);
 result := ((BarreAt <> 0) and (Count <4)  ) or
            ((BarreAt =0) and (Count <=4)   );

(* Barre verbieten:
---|--x-------
---|----------
---|----------
---|-----------
---|-x--------
---|--x------
*)

 if result and (BarreAt > 0) then
    begin
    if (FretBoard[0] = BarreAt+3) and (FretBoard[5]= BarreAt+3)
                               then result := false;
		end;
end;


// Nur für Entwicklung
procedure ShowFreBoard (FretBoard: TChord;BarreAt: Integer);
const LE = LineEnding;
var s : string = '';
    i : integer;
    begin
    s := 'BarreAt '+IntToStr(BarreAt) +LE;
    for i := 0 to 5 do s := s + IntTostr(FretBoard[i]) + LE;
    showMessage (s);
		end;

procedure TForm1.Button2Click(Sender: TObject);
var BarreAt,i,x : Integer;
    ok : Boolean;
    s : string;
begin
   Image1.Canvas.Brush.Color := clWhite;
   Image1.Canvas.FillRect (0,0,Image1.Width, Image1.Height);
   //  Anzeige Akkord
   s := RadioGroup1.Items[RadioGroup1.ItemIndex]+'-' +
        RadioGroup2.Items[RadioGroup2.ItemIndex];
   if RadioGroup3.ItemIndex>0 then s := s +' ' +
        RadioGroup3.Items[RadioGroup3.ItemIndex];
   x := (Image1.width - Image1.Canvas.TextWidth(s) ) div 2;
   Image1.Canvas.TextOut(x,3,s);

   BuildSet;
   if CheckBox1.checked then BarreAt := 1 else BarreAt := 0;
   for i := 0 to 2 do
   begin
   repeat
	    BuildFretBoard(BarreAt);
	    ok := FingersOK(FretBoard,BarreAt);
	    //ShowFreBoard (FretBoard,BarreAt);
	    if not OK then Inc (BarreAt);
   until ok;

   DrawChord(FretBoard,BarreAt,i*FretbordDist);
   inc (BarreAt);
	 end; // for i
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
   close;
end;


end.

